
html {
  font-size: 100% /* font-size of 100% is required for textbox labels to be correct size & relatively apply a11y font size changes across the DOM */;
}

.ove-textbox-focused {
  transition: transform 0.2s cubic-bezier(0.4, 0, 0.2, 1) 0s;
  width: 100%;
  height: 2px;
  display: block;
  top: -1px;
  background-color: #4285f4;
  -ms-transform: scaleX(0);
  -webkit-transform: scaleX(0);
  transform: scaleX(0);
  position: relative;
  z-index: 2;
}

.ove-textbox.ove-textbox-smart-label-active .ove-textbox-focused {
  -ms-transform: scaleX(1);
  -webkit-transform: scaleX(1);
  transform: scaleX(1);
}

.form-group.ove-textbox {
  margin-bottom: 1rem;
  line-height: 1.375rem;
}

/* beginregion Prevents .form-group element collapse from floated input/placeholder */
.form-group.ove-textbox::after {
  display: block;
  clear: both;
  content: "";
}
/* endregion */

.ove-textbox .form-control {
  background: transparent;
  border: none;
  border-bottom: solid 1px #e6e6e6;
  outline: none;
  box-shadow: none;
  padding: 0;
  border-radius: 0;
  font-size: 1rem;
  padding-bottom: 0.375rem;
}

.ove-textbox .form-control[disabled] {
  background-color: rgba(224, 229, 233, 0.35);
  color: rgba(134, 141, 146, 0.85);
}

  .ove-textbox input.form-control {
  height: inherit;
}

.ove-textbox textarea.form-control {
  height: 80px;
}

.ove-textbox label {
  font-weight: normal;
  line-height: 1.4;
  font-size: 0.875rem;
  color: rgba(0, 0, 0, 0.54);
  margin-bottom: 0;
}

.ove-textbox-smart-label {
  position: relative;
}

  .ove-textbox-smart-label label {
    -ms-transform: translateY(26px);
    -webkit-transform: translateY(26px);
    transform: translateY(26px);
    margin: 0;
    font-size: 0.95rem;
    line-height: 1.5rem;
    margin-bottom: 0.25rem;
    transition-duration: 0.2s;
    transition-timing-function: cubic-bezier(0.4, 0, 0.2, 1);
  }

  .ove-textbox-smart-label .form-control {
    position: relative;
  }

  .ove-textbox-smart-label.ove-textbox-smart-label-completed label {
    -ms-transform: translateY(0px);
    -webkit-transform: translateY(0px);
    transform: translateY(0px);
    font-size: 0.875rem;
    color: rgba(0, 0, 0, 0.54);
  }

.ove-textbox.has-success .form-control {
  color: #259b24;
  border-color: #259b24;
}

  .ove-textbox.has-success .form-control ~ .ove-textbox-focused {
    background-color: #259b24;
  }

  .ove-textbox.has-success .form-control ~ .has-error-text {
    color: #259b24;
    display: block;
  }

  .ove-textbox.has-success .form-control:focus {
    box-shadow: none;
  }

.ove-textbox-smart-label.ove-textbox-smart-label-completed.has-success label {
  color: #259b24;
}

.has-success .control-label,
.has-success .help-block {
  color: #259b24;
}

.ove-textbox.has-warning .form-control {
  color: #ffc107;
  border-color: #ffc107;
}

  .ove-textbox.has-warning .form-control ~ .ove-textbox-focused {
    background-color: #ffc107;
  }

  .ove-textbox.has-warning .form-control ~ .has-error-text {
    color: #ffc107;
    display: block;
  }

  .ove-textbox.has-warning .form-control:focus {
    box-shadow: none;
  }

.ove-textbox-smart-label.ove-textbox-smart-label-completed.has-warning label {
  color: #ffc107;
}

.has-warning .control-label,
.has-warning .help-block {
  color: #ffc107;
}

.ove-textbox.has-error .form-control {
  color: #ff5722;
  border-color: #ff5722;
}

  .ove-textbox.has-error .form-control ~ .ove-textbox-focused {
    background-color: #ff5722;
  }

  .ove-textbox.has-error .form-control ~ .has-error-text {
    color: #ff5722;
    display: block;
  }

  .ove-textbox.has-error .form-control:focus {
    box-shadow: none;
  }

.ove-textbox-smart-label.ove-textbox-smart-label-completed.has-error label {
  color: #ff5722;
}

.has-error .control-label,
.has-error .help-block {
  color: #ff5722;
}

.ove-textbox.has-error .form-control:invalid {
  color: form-state-colors("error");
}

  .ove-textbox.has-error .form-control:invalid ~ .ove-textbox-focused {
    background-color: form-state-colors("error");
  }

  .ove-textbox.has-error .form-control:invalid ~ .has-error-text {
    color: form-state-colors("error");
    display: block;
  }

.help-block {
  font-size: 14px;
  margin-top: 0;
}

.has-error-text {
  display: none;
}

.form-group-lg.ove-textbox .form-control {
  font-size: 1.25rem;
  height: 44px;
  line-height: 1.33333;
}

.form-group-lg.ove-textbox label {
  font-size: 1rem;
}

.form-group-lg.ove-textbox-smart-label label {
  font-size: 1.25rem;
  -ms-transform: translateY(36px);
  -webkit-transform: translateY(36px);
  transform: translateY(36px);
}

.form-group-lg.ove-textbox-smart-label.ove-textbox-smart-label-completed label {
  font-size: 1rem;
  -ms-transform: translateY(0);
  -webkit-transform: translateY(0);
  transform: translateY(0);
}

.form-group-sm.ove-textbox .form-control {
  font-size: 0.875rem;
  height: 30px;
  line-height: 1.33333;
}

.form-group-sm.ove-textbox label {
  font-size: 0.625rem;
}

.form-group-sm.ove-textbox-smart-label label {
  font-size: 0.875rem;
  -ms-transform: translateY(28px);
  -webkit-transform: translateY(28px);
  transform: translateY(28px);
}

.form-group-sm.ove-textbox-smart-label.ove-textbox-smart-label-completed label {
  font-size: 0.625rem;
  -ms-transform: translateY(0);
  -webkit-transform: translateY(0);
  transform: translateY(0);
}

.ove-textbox .input-group-addon {
  border: none;
  background-color: transparent;
  padding: 0;
}

  .ove-textbox .input-group-addon:first-child {
    padding-right: 16px;
  }

  .ove-textbox .input-group-addon:last-child {
    padding-left: 16px;
  }

.ove-textbox .input-group .form-control {
  float: inherit;
  z-index: inherit;
}

.ove-input-group-label {
  padding-left: 40px;
}
